//+------------------------------------------------------------------+
//|                                            ay-TPOChart.v1.31.mq4 |
//|                         Copyright  2012, ahmad.yani@hotmail.com |
//|                                          http://eyesfx.web44.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, ahmad.yani@hotmail.com"
#property link      "http://eyesfx.web44.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_minimum 0
          
//<--Global Vars

//+------------------------------------------------------------------+
#include <ay-TPOChart.v1.32\inc.mqh>
//+------------------------------------------------------------------+
int init()
{
  // selfFakeTick(250);
   initMP(); 
   
   return(0);
}

//+------------------------------------------------------------------+
int deinit()
{
   delObjs();

   string fn = StringConcatenate(gsCmdDataRelPath, "OnOff.", giHWnd, ".ini");
      
   switch(UninitializeReason())
   {
      case REASON_CHARTCLOSE:
      case REASON_REMOVE:    
         //GlobalVariableDel( "mpcmd." + hwnd ); 
         killSelfFakeTick(); 
         FileDelete(fn);
         break; 
      //case REASON_RECOMPILE: 
      //case REASON_CHARTCHANGE:
      //case REASON_PARAMETERS:
      //case REASON_ACCOUNT:   break; 
   }      
    
   return(0);
}

//+------------------------------------------------------------------+
int start()
{
   selfFakeTick(250);
      
   static int lasttick;  
   int currtick = GetTickCount();
   //if (!isTimeForUpdate() || !isHistoryOK(giDataTf)) return(0);  
   static bool isfirstrun = true;
   //static bool isbusy; 
   static datetime  dtstartprofile0;
   
   int      i, irow, iprof, startprofile, startprofile0, laststartprofile;

   double     hh, ll
            , rhh  //round hh to rowheight
            , rll  //round ll to rowheight
            ; 
   int        startbar, endbar, rowcount;    
   double     mpdata  [][MPSIZE];
   int        mplines   [MPLNSIZE];
   double     mptotal   [MPTSIZE];
   int        mpletter[][MPLTSIZE];   
   //bool       settingchanged = updateOnOffSetting();
   
   double  open;
   double  close;
   double  vah;
   double  val;
   double  poc;
   int     maxtpo;
   int     numbar;
   int     ibstartbar;
   int     maxibendbar;
   int     ibendbar;   
   double  ibh, ibl, dibh, dibl;
         
   static bool winmpcmdloaded = false;   
         
   if ( giHWnd == 0) giHWnd = WindowHandle(gsSym, Period());
   
   //while (giHWnd==0) giHWnd = WindowHandle(gsSym, Period());
   
   //if ( giHWnd == 0) return( restart() );
   
   //Print(currtick, " ", giHWnd);
   
   if (giWinId !=0) 
   {
      showTimeLeft();
      //change color scheme only if chart background change.
      //if (AutoColorScheme) autoColor(giHWnd);
   }
   
   if (!winmpcmdloaded && giHWnd > 0)
   {                
      int mdihwnd = GetParent( GetParent(giHWnd)/*chart wnd*/); 
      
      writeOnOffIniFile();
      
      string arg = StringConcatenate(mdihwnd, "|", gsCmdDataAbsPath);
      string exe = TerminalPath()+"\\experts\\libraries\\mpcmd.exe";
      int retval = ShellExecuteA(NULL, "", exe, arg, gsCmdDataAbsPath, 5);    
      
      //If the function succeeds, it returns a value greater than 32 >> msdn
      winmpcmdloaded = (retval>32);                    
   }
   
   
  // if (!winmpcmdloaded) return(0);
      
   //if (!isHistoryOK(giDataTf)) return(0); 
      
   if (isfirstrun) 
   {       
      if (giHWnd==0) return(0);
      if (AutoColorScheme && !autoColor(giHWnd)) return(0);
      giWinId = WindowFind(gsWinName);
      displaySettingInfo(); 
      updateSubWinHeight(); 
      showLegend();                  
   }
   
   if (currtick-lasttick < UpdateInterval) return(0);   
   else lasttick = currtick;//{Print(currtick-lasttick);lasttick = currtick;}
   
   getSBEBnLookBack();
   //--giLookBack == LookBack when firstrun or new profile formed
   if (giLookBack == LookBack) delObjs(gsPref + "#");   
   
   //--giLookBack == LookBack when there is new command from MPCmd
   if (  checkMPCmd() )
   {                                            
      updateSubWinHeight();                              
      delObjs(gsPref + "#");  
      giLookBack = LookBack;            
   }   
   else 
   {
      delObjs(gsPref + "#0.");// + (giLookBack-1)); 
   }
   
   //+------------------------------------------------------------------+
   //|>>main loop                                                       |
   //+------------------------------------------------------------------+
   for (iprof=0; iprof<giLookBack; iprof++)
   {

      string profnum = "#"+iprof, strtime;
      
      if (giaMergeProfile[iprof][IDXSTART] != -1)
      {
         if (giaMergeProfile[iprof][IDXEND] == iprof)
         {
            startbar = giaSBEB[ giaMergeProfile[iprof][IDXSTART] ] [IDXSTART];
            endbar   = giaSBEB[ giaMergeProfile[iprof][IDXEND]   ] [IDXEND];    
            
            profnum = StringConcatenate("#", giaMergeProfile[iprof][IDXEND], "-",  giaMergeProfile[iprof][IDXSTART]);
         }      
         else continue;
      }
      else
      {
         startbar = giaSBEB[iprof][0];
         endbar   = giaSBEB[iprof][1];            
         
         if (startbar == -1) continue;
      }                        
      //-->daily session profile   
      //+------------------------------------------------------------------+
      //|                                                                  |
      //+------------------------------------------------------------------+         
      if (gbaSplitSession[iprof] && giProfileTf == PERIOD_D1)
      {
         giActiveSession = 0;
         for (int ises=2; ises>=0; ises--)
         {
            int sstartbar = giaSesSBEB[iprof][ises][0];
            int sendbar   = giaSesSBEB[iprof][ises][1];
            
            if (sstartbar == -1) continue;  
            //Print ( iprof, " ", ises, " sb ", giaSesSBEB[iprof][ises][0], " eb ", giaSesSBEB[iprof][ises][1] );
            doMT4MpGet( sstartbar, sendbar, hh, ll, rhh, rll, rowcount, mpdata, mplines, mptotal, mpletter );
            
            open   = gdaRates[sstartbar][_OPEN];
            close  = gdaRates[sendbar][_CLOSE];               
            vah    = MathMin(mpdata[ mplines[MPL_TPOVAH] ][MP_PRICE], hh);
            val    = MathMax(mpdata[ mplines[MPL_TPOVAL] ][MP_PRICE] - gdRowInPips, ll);
            poc    = mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE] - 0.5*gdRowInPips;  
            maxtpo = mpdata[ mplines[MPL_TPOPOC] ][MP_TPO];    
            numbar = sstartbar - sendbar;
      
            startprofile = laststartprofile + maxtpo + PROFILESPACE;                 
            if ( gbaSplitProfileInSession[iprof][ises] ) startprofile += (numbar*2)+(PROFILESPACE+1);   
                        
            laststartprofile = startprofile;
            //-->Draw OHLCBar, Value Area, POC Line            
            if (ShowOHLCBar) drawBar( "#" +iprof+"."+ises, startprofile+2, open, hh, ll, close );
            /*
            createRect( "#"+iprof+"."+ises+".va" 
               , vah, Time[ startprofile + 1 ]
               , val, Time[ startprofile - (maxtpo+1) ]
               , VAColor );
            */
            createTl("#" + iprof + "."+ises+ ".va"
               , Time[ startprofile - (maxtpo) ], vah 
               , Time[ startprofile - (maxtpo) ], val
               , VAColor, STYLE_SOLID, 1, true
               );   
            createTl("#" + iprof + "."+ises+ ".vah"
               , Time[ startprofile - (maxtpo-1) ]  , vah 
               , Time[ startprofile - (maxtpo)   ], vah
               , VAColor, STYLE_SOLID, 2, true
               );  
            createTl("#" + iprof + "."+ises+ ".val"
               , Time[ startprofile - (maxtpo-1) ]  , val 
               , Time[ startprofile - (maxtpo)   ], val
               , VAColor, STYLE_SOLID, 2, true
               );    
            createTl("#"+iprof+"."+ises+".poc"
               , Time[startprofile+1], poc 
               , Time[startprofile - (maxtpo)], poc
               , POCColor, STYLE_SOLID, 3, true
               ); 
               
            //-->Initial Balance, DIB  
            if (ShowIB || ShowDIB)
            {      
               ibstartbar = getBarByTime(gsSym, giSesIBTf, iTime(gsSym, giDataTf, sstartbar), true);
               maxibendbar= getBarByTime(gsSym, giSesIBTf, iTime(gsSym, giDataTf, sendbar), false);
               ibendbar   = ibstartbar-(giSesIBNumBars-1);

               if (ibendbar<maxibendbar) ibendbar = maxibendbar;
               
               getHHLL(gsSym, giSesIBTf, ibstartbar, ibendbar, ibh, ibl);
               dibh = ibh+(ibh-ibl);
               dibl = ibl-(ibh-ibl);         
               if (ShowIB)                                
                  createTl("#" + iprof + "." + ises + ".2.0.ib", Time[startprofile+1], ibh 
                     , Time[startprofile+1], ibl, IBColor, STYLE_SOLID, 3, false);                                                   
      
               if (ShowDIB)
                  createTl("#" + iprof + "." + ises + ".1.0.dib", Time[startprofile+1], dibh
                     , Time[startprofile+1], dibl, DIBColor, STYLE_SOLID, 3, false);     
            }
            //<--Initial Balance, DIB             
            
            drawTPOChartSession(iprof, ises, startprofile, sstartbar, numbar, mpdata, mplines, mpletter);
            
            if (ises>giActiveSession) giActiveSession = ises;
            
            if (ises==giActiveSession)
            {
               gdCurrPSHigh=hh;
               gdCurrPSLow=ll;
            }
         
         }
         
         if (iprof==0) laststartprofile += PROFILESPACE-1;
         
         if (gbaHideDailySplittedToSession[iprof]) 
         {
                        
            if (giProfileTf<PERIOD_D1) strtime = TimeToStr(iTime(gsSym, giDataTf, startbar), TIME_MINUTES);
            else strtime = TimeToStr(iTime(gsSym, giDataTf, startbar));
            
            string info = addStr(strtime + " " + profnum, " ", INFOLENGTH, false); 
            
            createText( "#" + iprof + ".info." + i   
               , Time[startprofile] + (4*Period()*60) 
               , 1
               , info
               , FONTSIZE, FONTNAME, InfoColor, giWinId
               );              
            
            if (iprof==0) 
            {
               laststartprofile -= (PROFILESPACE-1);
               startprofile0 = laststartprofile;
            }
            
            continue;
         }
      }
      //<--daily session profile      
      //+------------------------------------------------------------------+
      //|                                                                  |
      //+------------------------------------------------------------------+
      
      doMT4MpGet( startbar, endbar, hh, ll, rhh, rll, rowcount, mpdata, mplines, mptotal, mpletter );    
            
      open   = gdaRates[startbar][_OPEN];
      close  = gdaRates[endbar][_CLOSE];               
      vah    = MathMin(mpdata[ mplines[MPL_TPOVAH] ][MP_PRICE], hh);
      val    = MathMax(mpdata[ mplines[MPL_TPOVAL] ][MP_PRICE] - gdRowInPips, ll);
      poc    = mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE] - 0.5*gdRowInPips;  
      maxtpo = mpdata[ mplines[MPL_TPOPOC] ][MP_TPO];    
      numbar = startbar - endbar;
      
      startprofile = laststartprofile + maxtpo;     
      if (iprof!=0) startprofile += PROFILESPACE;
      else startprofile += 1;
      
      if (  gbaSplitProfile[iprof] 
         && ModeLetter 
         && !(gbaSplitSession[iprof] && giProfileTf == PERIOD_D1)) 
         startprofile += (numbar*2)+4;
      
      if (!ModeLetter) startprofile++;
      
      laststartprofile = startprofile;
      
      if (iprof==0) startprofile0 = laststartprofile;
      
      //-->Draw OHLCBar, Value Area, POC Line            
      if (ShowOHLCBar) drawBar( "#"+iprof, startprofile+2, open, hh, ll, close );
      /*
      createRect( "#"+iprof+".va" 
         , vah, Time[ startprofile - (maxtpo) ]//Time[ startprofile + 1 ]
         , val, Time[ startprofile - (maxtpo+1) ]
         , VAColor );
      */
      createTl("#" + iprof + ".va"
         , Time[ startprofile - (maxtpo) ], vah 
         , Time[ startprofile - (maxtpo) ], val
         , VAColor, STYLE_SOLID, 1, true
         );   
      createTl("#" + iprof + ".vah"
         , Time[ startprofile - (maxtpo-1) ], vah 
         , Time[ startprofile - (maxtpo)   ], vah
         , VAColor, STYLE_SOLID, 2, true
         );  
      createTl("#" + iprof + ".val"
         , Time[ startprofile - (maxtpo-1) ], val 
         , Time[ startprofile - (maxtpo)   ], val
         , VAColor, STYLE_SOLID, 2, true
         );              
      createTl("#" + iprof + ".poc"
         , Time[startprofile+1], poc 
         , Time[startprofile - (maxtpo)], poc
         , POCColor, STYLE_SOLID, 3, true
         );                   
      //<--Draw OHLCBar, Value Area, POC Line    

      //-->TPO Chart/TPO Histogram
      if (ModeLetter)            
         drawTPOChart(iprof, startprofile, startbar, numbar, mpdata, mplines, mpletter);       
      else      
         drawTPOHistogram(iprof, startprofile, numbar, mpdata);                              
      //<--TPO Chart/TPO Histogram 
            
      //-->Initial Balance, DIB  
      if (ShowIB || ShowDIB)
      {      
         ibstartbar = getBarByTime(gsSym, giIBTf, iTime(gsSym, giDataTf, startbar), true);
         maxibendbar= getBarByTime(gsSym, giIBTf, iTime(gsSym, giDataTf, endbar), false);
         ibendbar   = ibstartbar-(giIBNumBars-1);

         if (ibendbar<maxibendbar) ibendbar = maxibendbar;
               
         getHHLL(gsSym, giIBTf, ibstartbar, ibendbar, ibh, ibl);
         dibh = ibh+(ibh-ibl);
         dibl = ibl-(ibh-ibl);         
         if (ShowIB)                                
            createTl("#" + iprof + ".2.0.ib", Time[startprofile+1], ibh 
               , Time[startprofile+1], ibl, IBColor, STYLE_SOLID, 3, false);                                                   
      
         if (ShowDIB)
            createTl("#" + iprof + ".1.0.dib", Time[startprofile+1], dibh
               , Time[startprofile+1], dibl, DIBColor, STYLE_SOLID, 3, false);     
      }
      //<--Initial Balance, DIB     
      
      //-->ProfileInfo
      
      if (startbar-endbar<3 && iprof>0) continue;
      
      string strinfo[16];
      int rf = getRF(startbar, endbar, giDataTf);
      double qclose ;
      if (hh-ll>0) qclose = ( (close - ll) / (hh-ll) ) * 100.0;
      
      if (giProfileTf<PERIOD_D1) strtime = TimeToStr(iTime(gsSym, giDataTf, startbar), TIME_MINUTES);
      else strtime = TimeToStr(iTime(gsSym, giDataTf, startbar), TIME_DATE);
             
      strinfo[0]  = addStr(strtime + " " + profnum                        , " ", INFOLENGTH, false);      
      strinfo[1]  = addStr("O       : " + DoubleToStr(open, giDigits)     , " ", INFOLENGTH, false); 
      strinfo[2]  = addStr("H       : " + DoubleToStr(hh, giDigits)       , " ", INFOLENGTH, false); 
      strinfo[3]  = addStr("L       : " + DoubleToStr(ll, giDigits)       , " ", INFOLENGTH, false); 
      strinfo[4]  = addStr("C       : " + DoubleToStr(close, giDigits)    , " ", INFOLENGTH, false);          
      strinfo[5]  = addStr("V       : " + DoubleToStr(mptotal[MPT_VOL], 0), " ", INFOLENGTH, false);  
      strinfo[6]  = addStr("RANGE   : " + DoubleToStr((hh-ll)/gdPoint, 0) , " ", INFOLENGTH, false); 
      strinfo[7]  = addStr("VAH     : " + DoubleToStr(vah, giDigits)      , " ", INFOLENGTH, false); 
      strinfo[8]  = addStr("POC     : " + DoubleToStr(poc, giDigits)      , " ", INFOLENGTH, false); 
      strinfo[9]  = addStr("VAL     : " + DoubleToStr(val, giDigits)      , " ", INFOLENGTH, false); 
      strinfo[10] = addStr("IBH     : " + DoubleToStr(ibh, giDigits)      , " ", INFOLENGTH, false); 
      strinfo[11] = addStr("IBL     : " + DoubleToStr(ibl, giDigits)      , " ", INFOLENGTH, false); 
      strinfo[12] = addStr("DIBH    : " + DoubleToStr(dibh, giDigits)     , " ", INFOLENGTH, false); 
      strinfo[13] = addStr("DIBL    : " + DoubleToStr(dibl, giDigits)     , " ", INFOLENGTH, false); 
      strinfo[14] = addStr("RF      : " + DoubleToStr(rf, 0)              , " ", INFOLENGTH, false); 
      strinfo[15] = addStr("QClose  : " + DoubleToStr(qclose, 2) + "%"    , " ", INFOLENGTH, false);  
      
      int maxrow = ArraySize(strinfo);
      if (!ShowProfileInfo) maxrow = 1;
      for (i=0; i<maxrow; i++)
      {
         createText( "#" + iprof + ".info." + i   
            , Time[startprofile] + (4*Period()*60) 
            , maxrow - i
            , strinfo[i]
            , FONTSIZE, FONTNAME, InfoColor, giWinId
            );                  
      }                           
      //<--ProfileInfo              
                       
   } 
   //+------------------------------------------------------------------+
   //|<<main loop                                                       |
   //+------------------------------------------------------------------+
   
   
   //--move all obj profile when profile 0 position on chart change
   int adj = startprofile0 - iBarShift(NULL, 0, dtstartprofile0); 
   
   if ( adj!=0 && giLookBack != LookBack)
   {          
      
      int objtotal  = ObjectsTotal();
      //-->move obj profile > #0       
      for (int iobj = objtotal-1; iobj>=0; iobj--)
      {
         string objname = ObjectName(iobj);   
         int    objtype = ObjectType(objname);                            
   
         if (StringFind(objname, gsPref) == -1) continue;         
            
         //-->move all prev profile by [adj] period                
         if ( getIProfObj(objname) != 0 )  moveObj(objname, objtype, adj);               
      }        
      //<--move obj profile > #0
          
   }
      
   dtstartprofile0 = Time[startprofile0];   
   
   double phighlight = MathCeil(gdaRates[0][_CLOSE]/gdRowInPips) * gdRowInPips;   
   
   createRect( "phighlight" 
         , phighlight            , Time[0] + (1000*Period()*60)
         , phighlight-gdRowInPips, Time[Bars-1]
         , RowHighlightColor, true);//C'5,5,5' );      
   
   
   if (isfirstrun) isfirstrun = false;
   
   if (PrintTimeConsume) Print("time consume ", GetTickCount() - currtick, " ms");
   
   return(0);
}


      /*//>> this block not work smooth
      if (!isRowPriceChange() && !isfirstrun && !newBarDataTf())
      {
         if (ShowOHLCBar)
         {
            ObjectSet(gsPref+"#0.bar.c", OBJPROP_PRICE1, Close[0]);
            ObjectSet(gsPref+"#0.bar.c", OBJPROP_PRICE2, Close[0]);
         
            if (ObjectFind(gsPref+"#0."+giActiveSession+".bar.c") != -1)
            {
               ObjectSet(gsPref+"#0."+giActiveSession+".bar.c", OBJPROP_PRICE1, Close[0]);
               ObjectSet(gsPref+"#0."+giActiveSession+".bar.c", OBJPROP_PRICE2, Close[0]);
               
               if (Close[0]>gdCurrPSHigh)
               {
                  gdCurrPSHigh = Close[0];
                  ObjectSet(gsPref+"#0."+giActiveSession+".bar.spread", OBJPROP_PRICE1, Close[0]);
               }
               
               if (Close[0]<gdCurrPSLow)
               {
                  gdCurrPSLow = Close[0];
                  ObjectSet(gsPref+"#0."+giActiveSession+".bar.spread", OBJPROP_PRICE2, Close[0]);
               }
            }
         }
       
         return(0);
      
      }
      */